# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Python.gitlab-ci.yml

# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/python/tags/
default:
  image: python:3.12
#  tags:
#    - docker


# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# https://pip.pypa.io/en/stable/topics/caching/
cache:
  paths:
    - .cache/pip

before_script:
  - python --version ; pip --version  # For debugging
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate

test:
  script:
    - pip install -e .[test]
    - coverage run -m pytest
    - coverage report
    - coverage xml
  coverage: '/^TOTAL.+?([\d.]+\%)$/'
  artifacts:
    expire_in: 3 days
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

# run:
#   script:
#     - pip install .
#     # run the command here
#   artifacts:
#     paths:


pages:
  script:
    - pip install -e .[docs]
    - sphinx-build -b html docs/ public/
    # - mv build/html/ public/
  artifacts:
    paths:
      - public
  rules:
    # Deploy for 'main' branch (latest stable version)
    - if: '$CI_COMMIT_BRANCH == "main"'
    # Deploy for 'joss' branch (JOSS-specific version)
    - if: '$CI_COMMIT_BRANCH == "joss"'

# deploy:
#   stage: deploy
#   script: echo "Define your deployment script!"
#   environment: production
